#include "alternate-gpio.hpp"
#include "i2c-gpio-init.hpp"

#ifndef I2C_GPIO_H
#define I2C_GPIO_H

namespace stm32f072xb {

template <Port T>
class I2cGpio : public AlternateGpio<T> {
   public:
	I2cGpio(const I2cGpioInit& gpioInit) : AlternateGpio<T>(gpioInit) {
		// Select open drain output type
		SET_BIT(this->getGpio()->OTYPER, 1UL << (this->getPin()));

		// Select high speed output
		SET_BIT(this->getGpio()->OSPEEDR, 0x3UL << (this->getPin() * 2));
	}
};

}  // namespace stm32f072xb

#endif
